""" Extract all the aliases of dimension indices """

from ufl.algorithms import MultiFunction


class _DimensionIndexMapping(MultiFunction):
    call = MultiFunction.__call__

    def __call__(self, o):
        self.shape = 0
        self.dimension_index_dict = {}
        self.call(o)

        return self.dimension_index_dict

    def expr(self, o):
        for op in o.ufl_operands:
            self.call(op)

    def function_view(self, o):
        from ufl.functionview import select_subelement
        subelement = select_subelement(o.ufl_operands[0].ufl_element(), o.ufl_operands[1])
        self.shape = len(subelement.value_shape())

    def coefficient(self, o):
        self.shape = len(o.ufl_element().value_shape())

    def indexed(self, o):
        self.call(o.ufl_operands[0])
        for i in range(self.shape):
            from dune.perftool.pdelab.geometry import dimension_iname
            self.dimension_index_dict[o.ufl_operands[1][i]] = dimension_iname(context='arg', count=i)
        self.shape = 0


def dimension_index_mapping(expr):
    return _DimensionIndexMapping()(expr)
